"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _plugins = require("./plugins");

var _util = require("./util");

/**************************************************
 * Created by nanyuantingfeng on 27/10/2017 16:25.
 **************************************************/
function _default(_x, _x2) {
  return _ref.apply(this, arguments);
}

function _ref() {
  _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(context, next) {
    var compress, plugins, dll, ENV, cwd, outputPath, _context$records, records, _context$aggressive, aggressive, _context$analyzer, analyzer, _context$optimizeLoda, optimizeLodash;

    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.plugins = [new _plugins.FriendlyErrorsWebpackPlugin({
              onErrors: function onErrors(severity, errors) {
                if (severity !== 'error') {
                  _util.notifier.notify({
                    title: 'hollow cli',
                    message: 'warn',
                    contentImage: _path.default.join(__dirname, '../assets/warn.png'),
                    sound: 'Glass'
                  });

                  return;
                }

                var error = errors[0];

                _util.notifier.notify({
                  title: 'hollow cli',
                  message: "".concat(severity, " : ").concat(error ? error.name : error),
                  subtitle: error ? error.file : error || '',
                  contentImage: _path.default.join(__dirname, '../assets/fail.png'),
                  sound: 'Glass'
                });
              }
            }), new _plugins.ProgressPlugin(_util.fnProgressHandler)];
            next();
            compress = context.compress, plugins = context.plugins, dll = context.dll, ENV = context.ENV;

            if (!Array.isArray(dll)) {
              context.webpackConfig.optimization = {
                splitChunks: {
                  chunks: 'all',
                  cacheGroups: {
                    default: false,
                    vendors: false,
                    vendor: {
                      test: /node_modules/,
                      name: 'vendor',
                      chunks: 'initial',
                      enforce: true
                    },
                    common: {
                      name: 'common',
                      chunks: 'all',
                      minChunks: 3,
                      reuseExistingChunk: true,
                      enforce: true
                    },
                    styles: {
                      name: 'styles',
                      chunks: 'all',
                      test: /\.css$/,
                      enforce: true,
                      priority: 50
                    }
                  }
                },
                runtimeChunk: false,
                //common
                removeAvailableModules: true,
                removeEmptyChunks: true,
                mergeDuplicateChunks: true,
                // must be false
                sideEffects: false,
                //
                flagIncludedChunks: true,
                occurrenceOrder: true,
                concatenateModules: true,
                //
                usedExports: true,
                providedExports: true,
                noEmitOnErrors: true,
                namedModules: ENV.isDevelopment,
                namedChunks: ENV.isDevelopment
              };
            }

            context.webpackConfig.optimization.minimize = !!compress;

            if (compress) {
              context.webpackConfig.optimization.minimizer = [new _plugins.UglifyJsPlugin({
                uglifyOptions: {
                  output: {
                    comments: false // remove comments

                  },
                  compress: {
                    unused: true,
                    dead_code: true,
                    // big one--strip code that will never execute
                    warnings: false,
                    // good for prod apps so users can't peek behind curtain
                    drop_debugger: true,
                    conditionals: true,
                    evaluate: true,
                    drop_console: true,
                    // strips console statements
                    sequences: true,
                    booleans: true
                  }
                },
                cache: true,
                parallel: true,
                sourceMap: false
              }), new _plugins.OptimizeCSSAssetsPlugin({})];
            }

            cwd = context.cwd, outputPath = context.outputPath, _context$records = context.records, records = _context$records === void 0 ? false : _context$records, _context$aggressive = context.aggressive, aggressive = _context$aggressive === void 0 ? true : _context$aggressive, _context$analyzer = context.analyzer, analyzer = _context$analyzer === void 0 ? false : _context$analyzer, _context$optimizeLoda = context.optimizeLodash, optimizeLodash = _context$optimizeLoda === void 0 ? true : _context$optimizeLoda; // dll 模式下不能使用当前插件

            if (!Array.isArray(dll) && aggressive === true) {
              plugins.push(new _plugins.AggressiveSplittingPlugin((0, _util.getOptions)(aggressive, {
                minSize: 1,
                maxSize: 1024 * 1024,
                chunkOverhead: 0,
                entryChunkMultiplicator: 1
              })));
            }

            context.plugins = plugins;

            if (records) {
              context.webpackConfig.recordsOutputPath = _path.default.join(cwd, outputPath, (0, _util.getOptions)(records, 'records.json'));
            }

            if (analyzer) {
              plugins.push(new _plugins.BundleAnalyzerPlugin((0, _util.getOptions)(analyzer)));
            }

            plugins.push(new _plugins.IgnorePlugin(/^\.\/locale$/, /moment$/));

            if (optimizeLodash) {
              plugins.push(new _plugins.LodashWebpackPlugin((0, _util.getOptions)(optimizeLodash, {
                shorthands: true,
                paths: true,
                cloning: true,
                flattening: true,
                exotics: true,
                collections: true,
                caching: true
              })));
            }

          case 13:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _ref.apply(this, arguments);
}